/*  HEAPFREE.C
 *  last mod.: 15-MAY-91
 */

#include <STDIO.H>
#include <L_MEM.H>

char msg[70];
struct far_heap_info_t heap_info;

/*-----------*/
void main(void)
{
int err_flag;
long heap_used;
Ulong max_size = mem_max(&err_flag);

if ( err_flag )
    printf("\nError: %s\n",mem_err_msg(err_flag,msg));
else
    {
    far_heap_info(&heap_info);
    if ( !heap_info.heap_ok )
        printf("\nFar heap is not OK.\n");
    else
        {
        printf("\nThe far heap begins at %Fp",heap_info.heap_bottom);
        printf("\ and ends at %Fp.",heap_info.heap_top);
        printf("\nThere are %u blocks in the far heap",heap_info.blocks);
        printf(" and %u of these blocks %s free.",
            heap_info.free_blocks,(heap_info.free_blocks==1?"is":"are"));
        printf("\nLargest free block = %lu bytes (%luK)",
            max_size,max_size>>10);
        printf("\nFree space in the far heap = %ld bytes (%ldK)",
            heap_info.heap_free,heap_info.heap_free>>10);
        printf("\nTotal space in the far heap = %ld bytes (%ldK)",
            heap_info.heap_size,heap_info.heap_size>>10);
        heap_used = heap_info.heap_size - heap_info.heap_free;
        printf("\nPercentage of far heap in use = %d%%\n",
            (100*heap_used)/heap_info.heap_size);
        }
    }
}
